unit Ulform;

interface
uses {$IFNDEF DLL}
     Controls,
     {$ENDIF}
     {$IFDEF TEST}
     UTest,
     {$ENDIF}
     WinTypes;
{$IFDEF WIN32}
Var
{$ELSE}
Const
{$ENDIF}
  paramULForm: Longint = 0;

Const
  {Parametry dla SetParam}
  sp_FormulSerw = $0001;  {Wywoanie FormulSerw zamiast FormIPS}

  {Parametry dla OpenWidokFormul}
  ow_bezEdycji = $40;
  ow_pytajOZapisanie = $80;
  ow_child = $20;
  ow_ukrytyZapis = $10;


  {Parametry dla PrintFormul}
  pf_CichyDruk = $01;

  {Parametry dla SetTextformul}
  stf_Formatuj = $01;
  stf_Przelicz = $02;
  stf_SprawdzanieBledow = $04;

{$IFNDEF DLL}
const
  WaitCursor: TCursor = crHourGlass;
{$ENDIF}

{$IFDEF WIN32}
function FormulExists:bool; stdcall;
function SetParam(param:Longint):bool; stdcall;
function LoadSerwer:word; stdcall;
function LoadSerwerFree(path:PChar):word; stdcall;
procedure FreeSerwer; stdcall;
function FormVersion:longint; stdcall;
function CreateFormul(symbol,identyfikator:pChar; param:longint):longint; stdcall;
function DeleteFormul(formul:longint; param:longint):boolean; stdcall;
function DeleteFormul2(formul:longint; param:longint):bool; stdcall;
function OpenWidokFormul(formul:longint; opis:pChar; parent:hWnd; param:longint):word; stdcall;
function OpenWidokFormul32(formul:longint; opis:pChar; parent:hWnd; param:longint):dword; stdcall;
function CloseWidokFormul(formul:longint):Bool; stdCall;
function GetWidokHandle(formul:Longint):HWnd; stdCall;
function SetTextFormul(formul:longint; tx:pChar; formatuj,przelicz:bool):longint; stdcall;
function SetTextFormulEx(formul:longint; tx:pChar; param:Longint):longint; stdcall;
function GetTextFormul(formul:longint; tx:pChar; maxTx:longint; konwertuj:bool):longint; stdcall;
function GetErrorList(formul:longint; tx:pChar; maxTx:longint):longint; stdcall;
function LoadTextFormul(formul:longint; year:Word):Bool; stdcall;
function OpenWydrukFormul(formul:longint; opis:pChar; parent:hWnd; var odStr,doStr:word; param:longint):bool; stdcall;
function OpenWydrukFormul_C(formul:longint; opis:pChar; parent:hWnd; odStr,doStr:PWord; param:longint):bool; stdcall;
function PrintFormul(formul:longint; opis:pChar; parent:hWnd; odStr,doStr:word; param:longint):bool; stdcall;
function PrintFormulToPrinter(formul:longint; opis:pChar; parent:hWnd; odStr,doStr:word; param:longint;
  printerIndex:Integer):bool; stdcall;
function SetStrukPodDoch(formul:longint; struk:pChar):longint; stdcall;
function BylWydruk(formul:longint; var odStr,doStr:word):bool; stdcall;
function BylWydruk_C(formul:longint; odStr,doStr:PWord):bool; stdcall;
function BylaZmiana(formul:longint):bool; stdcall;
{$ELSE}
function FormulExists:bool; export;
function SetParam(param:Longint):bool; export;
function LoadSerwer:word; export;
function LoadSerwerFree(path:PChar):word; export;
procedure FreeSerwer; export;
function FormVersion:longint; export;
function CreateFormul(symbol,identyfikator:pChar; param:longint):longint; export;
function DeleteFormul(formul:longint; param:longint):boolean; export;
function DeleteFormul2(formul:longint; param:longint):bool; export;
function OpenWidokFormul(formul:longint; opis:pChar; parent:hWnd; param:longint):word; export;
function CloseWidokFormul(formul:longint):Bool; export;
function GetWidokHandle(formul:Longint):HWnd; export;
function SetTextFormul(formul:longint; tx:pChar; formatuj,przelicz:bool):longint; export;
function SetTextFormulEx(formul:longint; tx:pChar; param:Longint):longint; export;
function GetTextFormul(formul:longint; tx:pChar; maxTx:longint; konwertuj:bool):longint; export;
function GetErrorList(formul:longint; tx:pChar; maxTx:longint):longint; export;
function LoadTextFormul(formul:longint; year:Word):Bool; export;
function OpenWydrukFormul(formul:longint; opis:pChar; parent:hWnd; var odStr,doStr:word; param:longint):bool; export;
function OpenWydrukFormul_C(formul:longint; opis:pChar; parent:hWnd; odStr,doStr:PWord; param:longint):bool; export;
function PrintFormul(formul:longint; opis:pChar; parent:hWnd; odStr,doStr:word; param:longint):bool; export;
function PrintFormulToPrinter(formul:longint; opis:pChar; parent:hWnd; odStr,doStr:word; param:longint;
  printerIndex:Integer):bool; export;
function SetStrukPodDoch(formul:longint; struk:pChar):longint; export;
function BylWydruk(formul:longint; var odStr,doStr:word):bool; export;
function BylWydruk_C(formul:longint; odStr,doStr:PWord):bool; export;
function BylaZmiana(formul:longint):bool; export;

type
  ATOM = tAtom;
{$ENDIF}

{$IFNDEF DLL}
procedure StartWait;
procedure StopWait;
procedure UnitInit;
{$ENDIF}
implementation
uses {$IFNDEF DLL}
     Forms,
     {$ENDIF}
     Messages,IniFiles,SysUtils,Classes,WinProcs, Windows;


type
  TListaCreateFormul = class(TStringList)
    procedure AddParam(formul:Longint; symbol,ident,param:OpenString);
    procedure DeleteParam(formul:Longint);
  end;

{$IFDEF WIN32}
Var
{$ELSE}
const
{$ENDIF}
  listaFormul: tList = nil;
  formIPS: tHandle = 0;
  parametry: tStringList = nil;
  formIPSWindow: hWnd = 0;
  listaCreateFormul: TListaCreateFormul = nil;
  nplSerw: String[12] = 'formips.exe';

{$IFDEF WIN32}
Var
  hWOWLib: THandle = 0;
  WOWHandle16: TFarProc = nil;
  WOWHandle32: TFarProc = nil;
Type
  TWOWHandle16 = function(Handle:THandle; WOWType:LongWord):Word; stdcall;
  TWOWHandle32 = function(Handle:Word; WOWType:LongWord):THandle; stdcall;
{$ENDIF}

function HWND_16(parent:HWnd):Word;
begin
  Result:=parent;
  {$IFDEF WIN32}
  if hWOWLib=0 then
  begin
    hWOWLib:=LoadLibrary('WOW32.DLL');
    WowHandle16:=GetProcAddress(hWOWLib,'WOWHandle16');
  end;
  if WowHandle16<>nil then
    Result:=TWOWHandle16(WowHandle16)(parent,{WOW_TYPE_HWND}0);
  {$ENDIF}
end;

function HWND_32(parent:Word):HWnd;
begin
  Result:=parent;
  {$IFDEF WIN32}
  if hWOWLib=0 then
  begin
    hWOWLib:=LoadLibrary('WOW32.DLL');
    WowHandle32:=GetProcAddress(hWOWLib,'WOWHandle32');
  end;
  if WowHandle32<>nil then
    Result:=TWOWHandle32(WowHandle32)(parent,{WOW_TYPE_HWND}0);
  {$ENDIF}
end;

function StrPas(tx:pChar):string;
begin
  if tx<>nil then
    Result:=SysUtils.StrPas(tx)
  else
    Result:='';
end;

{$IFNDEF DLL}
{$IFDEF WIN32}
Var
{$ELSE}
Const
{$ENDIF}
  WaitCount: Integer = 0;
  SaveCursor: TCursor = crDefault;
procedure StartWait;
begin
  if WaitCount = 0 then begin
    SaveCursor := Screen.Cursor;
    Screen.Cursor := WaitCursor;
  end;
  Inc(WaitCount);
end;

procedure StopWait;
begin
  if WaitCount > 0 then begin
    Dec(WaitCount);
    if WaitCount = 0 then Screen.Cursor := SaveCursor;
  end;
end;
{$ELSE}
{$IFDEF WIN32}
Var
{$ELSE}
Const
{$ENDIF}
  WaitCount: Integer = 0;
  SaveCursor: hCursor = 0;
procedure StartWait;
begin
  if WaitCount = 0 then
  begin
  end;
  Inc(WaitCount);
end;

procedure StopWait;
begin
  if WaitCount > 0 then
  begin
    Dec(WaitCount);
    if WaitCount = 0 then
    begin
    end;
  end;
end;
{$ENDIF}



procedure TListaCreateFormul.AddParam;
begin
  Values[IntToStr(formul)+'_'+symbol]:='1';
  Values[IntToStr(formul)+'_'+ident]:='1';
  Values[IntToStr(formul)+'_'+param]:='1';
end;

procedure TListaCreateFormul.DeleteParam;
var
  f: Integer;
  tx: String[20];
begin
  tx:=IntToStr(formul)+'_';
  for f:=Count-1 downto 0 do 
    if Copy(Strings[f],1,Length(tx))=tx then
      Delete(f);
end;


function SetParam;
begin
  Result:=(param=0) or (sp_formulSerw and param<>0) {or};
  paramULForm:=param;
  if sp_formulSerw and param<>0 then
    nPlSerw:='formSerw.exe'
  else
    nPlSerw:='formips.exe';
  {$IFDEF TEST}
  Test.Add('SetParam '+nPlSerw);
  {$ENDIF}
end;

function CzyFormSerw:Boolean;
var
  katalog: string;
begin
  katalog:='';

  Result:=FileExists(katalog+'formSerw.exe');

  {$IFDEF TEST}
  Test.Add('CzyFormSerw '+katalog+'formserw.ok = '+IntToStr(Byte(Result)));
  {$ENDIF}

  if Result and (sp_formulSerw and paramULForm<>0) then
    Exit;

  Result:=Result and FileExists(katalog+'formserw.ok');
  if Result then
    SetParam(paramULForm or sp_formulSerw);

  {$IFDEF TEST}
  Test.Add('CzyFormSerw '+katalog+'formserw.ok = '+IntToStr(Byte(Result)));
  {$ENDIF}

end;

function FormulExists;
var
  katalog: string;
  plIni: tIniFile;

begin
  Result:=false;

  katalog:='';
  if sp_formulSerw and paramULForm=0 then
  begin
    plIni:=tIniFile.Create('win.ini');
    try
      katalog:=plIni.ReadString('formularze','katalog','');
    finally
      plIni.Free;
    end;

    {$IFDEF TEST}
    Test.Add('FormulExists katalog = '+katalog);
    {$ENDIF}

  end;
  if katalog<>'' then
  begin
    if Copy(katalog,length(katalog),1)<>'\' then
      katalog:=Concat(katalog,'\');
    Result:=FileExists(katalog+nPlSerw);

    {$IFDEF TEST}
    Test.Add('FormulExists nPlSerw = '+nPlSerw+' exists = '+IntToStr(Byte(Result)));
    {$ENDIF}

  end;

  if Result then
    Exit;


  Result:=CzyFormSerw;
end;

procedure ProcessMessages;
  function ProcessMessage(var Msg: TMsg): Boolean;
  begin
    Result := False;
    if PeekMessage(Msg, 0, 0, 0, PM_REMOVE) then
    begin
      Result := True;
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end;
  end;
var
  msg: tMsg;
begin
  While ProcessMessage(msg) do
end;

{$IFDEF WIN32}
Var
{$ELSE}
const
{$ENDIF}
  formularzeIPS: PChar = 'Tformularze_IPS';
  formSerwerIPS: PChar = 'Tformserw_IPS';
  SerwerName: PChar = 'Tformularze_IPS';

function LoadSerwer;
label
  skok1;
var
  plIni: tIniFile;
  {$IFNDEF WIN32}
  buf: pChar;
  katalog: string;
  {$ELSE}
  katalog: AnsiString;
  {$ENDIF}
begin
  serwerName:=formularzeIPS;
  formIPS:=2;
  {$IFNDEF WIN32}
  GetMem(buf,1024);
  {$ENDIF}
  try
    StartWait;
    formIPSWindow:=FindWindow(serwerName,nil);
    if formIPSWindow=0 then
    begin
      katalog:='';
      if sp_formulSerw and paramULForm=0 then
      begin
        plIni:=tIniFile.Create('win.ini');
        try
          katalog:=plIni.ReadString('formularze','katalog','');
        finally
          plIni.Free;
        end;

       {$IFDEF TEST}
       Test.Add('LoadSerwer katalog = '+katalog);
       {$ENDIF}
      end;
      if katalog<>'' then
      begin
        if Copy(katalog,length(katalog),1)<>'\' then
          katalog:=Concat(katalog,'\');
      end;


  skok1:

      if (katalog<>'') or (sp_formulSerw and paramULForm<>0) then
      begin

        {$IFDEF WIN32}
        katalog:=katalog+nPlSerw+' /SERWER'#0;
        formIPS:=WinExec(@katalog[1],sw_minimize);
        Repeat
          if formIPS>=32 then
            formIPSWindow:=FindWindow(serwerName,nil);
          ProcessMessages;
        Until (formIPS<32) or (formIPSWindow<>0);
        {$ELSE}
        formIPS:=WinExec(StrPLCopy(buf,katalog+nPlSerw+' /SERWER',1023),sw_minimize);
        Repeat
          if formIPS>=32 then
            formIPSWindow:=FindWindow(serwerName,nil);
          ProcessMessages;
        Until (formIPS<32) or (formIPSWindow<>0);
        {$ENDIF}
        {$IFDEF TEST}
        Test.Add('LoadSerwer formIPS= '+IntToStr(formIPS));
        {$ENDIF}
      end;
    end;


    if formIPSWindow=0 then
      if (sp_formulSerw and paramULForm=0) then
        if CzyFormSerw then
        begin
          katalog:='';
          Goto skok1;
        end;
  finally
    Result:=formIPSWindow;


    {$IFNDEF WIN32}
    FreeMem(buf,1024);
    {$ENDIF}
    StopWait;
  end;
end;

function LoadSerwerFree;
var
  {$IFNDEF WIN32}
  katalog: string;
  {$ELSE}
  katalog: AnsiString;
  {$ENDIF}
begin
  serwerName:=formserwerIPS;
  formIPS:=2;
  Result:=0;
  try
    StartWait;
    formIPSWindow:=FindWindow(serwerName,nil);
    if formIPSWindow=0 then
    begin
      if path=nil then
        Exit;
      katalog:=StrPas(path);
      if Copy(katalog,Length(katalog),1)<>'\' then
        katalog:=katalog+'\';
      {katalog:=katalog+'formserw.exe';}

      {$IFDEF TEST}
      Test.Add('LoadSerwerFree katalog= '+katalog);
      {$ENDIF}

      if FileExists(katalog+'formlic.exe') then
        katalog:=katalog+'formlic.exe'
      else
      if FileExists(katalog+'formserw.exe') then
        katalog:=katalog+'formserw.exe'
      else
        Exit;

      begin
        katalog:=katalog+' /SERWER'#0;
        formIPS:=WinExec(@katalog[1],sw_minimize);
        Repeat
          if formIPS>=32 then
            formIPSWindow:=FindWindow(serwerName,nil);
          ProcessMessages;
        Until (formIPS<32) or (formIPSWindow<>0);
        {$IFDEF TEST}
        Test.Add('LoadSerwerFree formIPS= '+IntToStr(formIPS));
        {$ENDIF}
      end;
    end;
  finally
    Result:=formIPSWindow;
    StopWait;
  end;
end;

function FormVersion;
begin
  Result:=0;
  if not IsWindow(formIPSWindow) then
    formIPSWindow:=FindWindow(serwerName,nil);
  if formIPSWindow=0 then
    LoadSerwer;
  if formIPSWindow<>0 then
    Result:=SendMessage(formIPSWindow,wm_User+9,0,0);
end;

function CreateFormul;
var
  hBuf: ATOM;
  CharStr: PChar;
begin
  Result:=0;
  hBuf:=0;
  try
    StartWait;
    if not IsWindow(formIPSWindow) then
      formIPSWindow:=FindWindow(serwerName,nil);
    if formIPSWindow=0 then
      LoadSerwer;

    {$IFDEF TEST}
    Test.Add('CreateFormul formIPSWindows= '+IntToStr(formIPSWindow));
    {$ENDIF}

    if formIPSWindow<>0 then
    begin
      parametry.Clear;
      parametry.Add(StrPas(symbol));
      parametry.Add(StrPas(identyfikator));
      parametry.Add('3');

      {$IFDEF TEST}
      Test.Add('CreateFormul param = '+StrPas(symbol)+' , '+StrPas(identyfikator)+' , 3');
      {$ENDIF}

      CharStr:=parametry.GetText;
      try
        hBuf:=GlobalAddAtom(CharStr);
        Result:=SendMessage(formIPSWindow,wm_User+9,1,MakeLong(0,hBuf));
        if Result<>0 then
        begin
          listaFormul.Add(pointer(Result));
          ListaCreateFormul.AddParam(Result,StrPas(symbol),StrPas(identyfikator),'3');
        end;
      finally
        GlobalDeleteAtom(hBuf);
        StrDispose(CharStr);
      end;
    end;
  finally
    StopWait;
  end;
end;

function DeleteFormul;
begin
  Result:=SendMessage(formIPSWindow,wm_User+9,2{+256*byte(zawsze)},formul)=0;
  if Result then
    if listaFormul.Count>0 then
      listaFormul.Delete(listaFormul.IndexOf(pointer(formul)));
end;

function DeleteFormul2;
begin
  Result:=DeleteFormul(formul,param);
end;

function OpenWidokFormul;
var
  hBuf: ATOM;
  msg: tMsg;
  wnd: hWnd;
  odp: longint;
  CharStr: PChar;
  fv: Longint;
  parentOrg: HWnd;
begin
  Result:=0;

  if (formIPSWindow<>0) and (formul<>0) then
  begin
    StartWait;
    hBuf:=0;
    try

      parentOrg:=parent;
      parent:=HWND_16(parent);
      {$IFDEF WIN32}
      if parent>$FFFF then
        parent:=0;
      {$ENDIF}

      fv:=FormVersion;

      parametry.Clear;
      parametry.Add(StrPas(opis));
      parametry.Add(IntToStr(parent));
      parametry.Add(IntToStr(param));

      {$IFDEF TEST}
      Test.Add('OpenWidokFormul param = '+StrPas(opis)+' , '+IntToStr(parent)+' , '+IntToStr(param));
      {$ENDIF}

      CharStr:=parametry.GetText;
      try
        hBuf:=GlobalAddAtom(CharStr);
        odp:=SendMessage(formIPSWindow,wm_User+9,3,MakeLong(formul,hBuf));
        wnd:=LoWord(odp);
        Result:=wnd;
        StopWait;
        if (wnd<>0) {and (parent<>0)} then
        begin
          if (param and $20=0) then
          begin
            BringWindowToTop(parentOrg);
            EnableWindow(parentOrg,false);
          end;
          if (param and $20=0) then
            Repeat
              {$IFNDEF WIN32}
              {WaitMessage;
              if PeekMessage(msg,0,0,0,pm_Remove) then}
              if GetMessage(msg,0,0,0) then
              begin
                TranslateMessage(msg);
                DispatchMessage(msg);
              end;
              {$ELSE}
              {WaitMessage;
              if PeekMessage(msg,0,0,0,pm_Remove) then}
              if GetMessage(msg,0,0,0) then
              begin
                TranslateMessage(msg);
                DispatchMessage(msg);
              end;
              {$ENDIF}
            Until ({(fv<=5) and }not IsWindow(wnd)) or ((fv>5) and (SendMessage(formIPSWindow,wm_User+9,18,wnd)=0));
          if (param and $20=0) then
            EnableWindow(parentOrg,true);
          {$IFNDEF WIN32}
          SetActiveWindow(parentOrg);
          {$ELSE}
          SetForegroundWindow(parentOrg);
          {$ENDIF}
        end;
      finally
        GlobalDeleteAtom(hBuf);
        StrDispose(CharStr);
      end;
    except
      StopWait;
    end;
  end;
end;

{$IFDEF WIN32}
function OpenWidokFormul32;
begin
  Result:=HWND_32(OpenWidokFormul(formul,opis,parent,param));
end;
{$ENDIF}

function CloseWidokFormul;
begin
  Result:=true;
  if formIPSWindow<>0 then
    Result:=Bool(SendMessage(formIPSWindow,wm_User+9,15,formul));
end;


function GetWidokHandle;
begin
  Result:=0;
  if formIPSWindow<>0 then
    Result:=HWND_32(SendMessage(formIPSWindow,wm_User+9,14,formul));
end;

function TworzAtomy(tx:pChar; lista:tList):atom;
var
  buf: pChar;
  tx2: pChar;
  txHBuf: array[0..10] of char;
  listaTx: tStringList;
  f: integer;
  lenTx: integer;
begin
  listaTx:=tStringList.Create;
  GetMem(buf,256);
  try
    tx2:=tx;
    lenTx:=StrLen(tx);
    Result:=0;
    for f:=0 to (lenTx div 240) do
    begin
      listaTx.Add(StrPas(StrLCopy(buf,tx2,240)));
      Inc(longint(tx2),240);
    end;
    for f:=listaTx.count-1 downto 0 do
    begin
      StrPCopy(buf,listaTx.strings[f]);
      if Result<>0 then
      begin
        StrCat(buf,#1);
        StrPCopy(txHBuf,IntToStr(Result));
        StrCat(buf,txhBuf);
      end;
      Result:=GlobalAddAtom(buf);
      lista.Add(pointer(Result));
    end;
  finally
    listaTx.Free;
    FreeMem(buf,256);
  end;
end;

function SetTextFormulEx;
var
  hBuf: ATOM;
  f: integer;
  lista: tList;
begin
  Result:=0;
  if (formIPSWindow<>0) and (formul<>0) then
  begin
    try
      lista:=tList.Create;
      try
        if tx<>nil then
          Result:=StrLen(tx)
        else
          Result:=0;

        {$IFDEF TEST}
        if tx<>nil then
          Test.Add('SetTextFormulEx tx= '+StrPas(tx)+' param= '+IntToStr(param))
        else
          Test.Add('SetTextFormulEx tx= nil, param= '+IntToStr(param));
        {$ENDIF}

        hBuf:=TworzAtomy(tx,lista);
        try
          SendMessage(formIPSWindow,wm_User+9,5+(256*Byte(param)),MakeLong(formul,hBuf));
        finally
          for f:=0 to lista.count-1 do
            GlobalDeleteAtom(LoWord(longint(lista.items[f])));
        end;
      finally
        lista.Free;
      end;
    finally
    end;
  end;
end;

function SetTextformul;
var
  param: Byte;
begin
  param:=0;
  if przelicz then
    param:=stf_przelicz
  else
    if formatuj then
      param:=stf_formatuj;
  Result:=SetTextFormulEx(formul,tx,param);
end;

procedure OdbierzAtomy(buf:pChar; hBuf:tAtom);
var
  buf255: pChar;
  pos: pChar;
  code: integer;
  dl: word;
begin
  buf[0]:=#0;
  GetMem(buf255,256);
  try
    dl:=0;
    Repeat
      GlobalGetAtomName(hBuf,buf255,256);
      GlobalDeleteAtom(hBuf);
      pos:=StrRScan(buf255,#1);
      if pos=nil then
        StrCat(buf,buf255)
      else
      begin
        Inc(dl,longint(pos)-longint(buf255));
        StrLCat(buf,buf255,dl);
        Inc(longint(pos));
        Val(pos,hBuf,code);
        if code<>0 then
        begin
          Dec(longint(pos));
          StrCat(buf,pos);
          pos:=nil;
        end;
      end;
    Until (pos=nil);
  finally
    FreeMem(buf255,256);
  end;
end;

function GetTextFormul;
var
  hBuf: ATOM;
  param: byte;
  odp: longint;
  {dlBuf: word;}
begin
  Result:=0;
  if tx<>nil then
  begin
    param:=0;
    if konwertuj then
      param:=$01;
    odp:=SendMessage(formIPSWindow,wm_User+9,6+(256*param),MakeLong(formul,0));
    hBuf:=LoWord(odp);
    {dlBuf:=HiWord(odp);}
    if hBuf<>0 then
      OdbierzAtomy(tx,hBuf);
    Result:=StrLen(tx);
  end;
end;

function GetErrorList;
var
  hBuf: ATOM;
  odp: longint;
  {dlBuf: word;}
begin
  Result:=0;
  if tx<>nil then
  begin
    odp:=SendMessage(formIPSWindow,wm_User+9,17,MakeLong(formul,0));
    hBuf:=LoWord(odp);
    {dlBuf:=HiWord(odp);}
    if hBuf<>0 then
      OdbierzAtomy(tx,hBuf);
    Result:=StrLen(tx);
  end;
end;

function LoadTextFormul;
var
  hBuf: ATOM;
  CharStr: PChar;
begin
  parametry.Clear;
  parametry.Add(IntToStr(year));
  CharStr:=parametry.GetText;
  hBuf:=GlobalAddAtom(CharStr);
  try
    Result:=Bool(SendMessage(formIPSWindow,wm_User+9,16,MakeLong(formul,hBuf)));
  finally
    GlobalDeleteAtom(hBuf);
    StrDispose(CharStr);
  end;
end;


function OpenWydrukFormul;
var
  hBuf: ATOM;
  odp: longint;
  msg: TMsg;
  nrPolecenia: Byte;
  CharStr: PChar;
  fv: Longint;
  parentOrg: HWnd;
begin
  Result:=false;
  if formIPSWindow<>0 then
  begin
    StartWait;
    try

      parentOrg:=parent;
      parent:=HWND_16(parent);
      {$IFDEF WIN32}
      if parent>$FFFF then
        parent:=0;
      {$ENDIF}

      parametry.Clear;
      parametry.Add(InttoStr(parent));
      if odStr>0 then
        parametry.Add(IntToStr(odStr))
      else
        parametry.Add('');
      if doStr>0 then
        parametry.Add(IntToStr(doStr))
      else
        parametry.Add('');
      parametry.Add(StrPas(opis));

      {$IFDEF TEST}
      Test.Add('OpenWydrukFormul param = '+IntToStr(parent)+' , '+IntToStr(OdStr)+' , '+IntToStr(DoStr)+' , '+StrPas(opis));
      {$ENDIF}

      CharStr:=parametry.GetText;
      hBuf:=GlobalAddAtom(CharStr);
      try
        StopWait;

        nrPolecenia:=9;
        fv:=FormVersion;
        if fv>3 then
          nrPolecenia:=13;

        odp:=SendMessage(formIPSWindow,wm_User+9,nrPolecenia,MakeLong(formul,hBuf));
        Result:=odp<>0;
        if Result and (nrPolecenia=13) then
        begin
          EnableWindow(parentOrg,false);
          Repeat
            {$IFNDEF WIN32}
            {WaitMessage;
            if PeekMessage(msg,0,0,0,pm_Remove) then
            begin
              TranslateMessage(msg);
              DispatchMessage(msg);
            end;}
            if GetMessage(msg,0,0,0) then
            begin
              TranslateMessage(msg);
              DispatchMessage(msg);
            end;
            {$ELSE}
            {WaitMessage;}
            Sleep(1);
            if PeekMessage(msg,0,0,0,pm_Remove) then
            begin
              TranslateMessage(msg);
              DispatchMessage(msg);
            end;
            {if GetMessage(msg,0,0,0) then
            begin
              TranslateMessage(msg);
              DispatchMessage(msg);
            end;}
            {$ENDIF}
          Until not IsWindow(formIPSWindow) or (SendMessage(formIPSWindow,wm_User+9,12,formul)=1);
          EnableWindow(parentOrg,true);

          if IsWindow(formIPSWindow) then
          begin
            odp:=SendMessage(formIPSWindow,wm_User+9,11,formul);
            Result:=odp<>0;
          end;
          {$IFNDEF WIN32}
          SetActiveWindow(parentOrg);
          {$ELSE}
          SetForegroundWindow(parentOrg);
          {$ENDIF}
        end;
        if Result then
        begin
          odStr:=LoWord(odp);
          doStr:=HiWord(odp);
        end;
      finally
        GlobalDeleteAtom(hBuf);
        StrDispose(CharStr);
      end;
    except
      StopWait;
    end;
  end;
end;

function OpenWydrukFormul_C;
var
  odStr0,doStr0: Word;
begin
  odStr0:=0;
  doStr0:=0;
  if odStr<>nil then
    odStr0:=odStr^;
  if doStr<>nil then
    doStr0:=doStr^;
  Result:=OpenWydrukFormul(formul,opis,parent,odStr0,doStr0,param);
  if odStr<>nil then
    odStr^:=odStr0;
  if doStr<>nil then
    doStr^:=doStr0;
end;

function PrintFormul0(formul:longint; opis:pChar; parent:hWnd; odStr,doStr:word; param:longint; printerIndex:Integer):bool;
var
  hBuf: ATOM;
  CharStr: PChar;
  {parentOrg: HWnd;}
begin
  Result:=false;
  if formIPSWindow<>0 then
  begin
    try
      StartWait;

      {parentOrg:=parent;}
      parent:=HWND_16(parent);
      {$IFDEF WIN32}
      if parent>$FFFF then
        parent:=0;
      {$ENDIF}

      parametry.Clear;
      parametry.Add(InttoStr(parent));
      if odStr>0 then
        parametry.Add(IntToStr(odStr))
      else
        parametry.Add('1');
      if doStr>0 then
        parametry.Add(IntToStr(doStr))
      else
        parametry.Add('999');
      parametry.Add(StrPas(opis));
      if FormVersion>4 then
      begin
        parametry.Add(IntToStr(param));
        parametry.Add(IntToStr(printerIndex));
      end;

      {$IFDEF TEST}
      Test.Add('PrintFormul0 param = '+IntToStr(parent)+' , '+IntToStr(OdStr)+' , '+IntToStr(DoStr)+' , '+StrPas(opis));
      {$ENDIF}

      CharStr:=parametry.GetText;
      hBuf:=GlobalAddAtom(CharStr);
      Result:=SendMessage(formIPSWindow,wm_User+9,8,MakeLong(formul,hBuf))<>0;
      GlobalDeleteAtom(hBuf);
      StrDispose(CharStr);
    finally

      StopWait;
    end;
  end;
end;

function PrintFormul;
begin
  Result:=PrintFormul0(formul,opis,parent,odStr,doStr,param,0);
end;

function PrintFormulToPrinter;
begin
  Result:=PrintFormul0(formul,opis,parent,odStr,doStr,param,printerIndex);
end;


function SetStrukPodDoch;
var
  hBuf: ATOM;
  lenTx: longint;
  f: integer;
  lista: tList;
begin
  Result:=0;
  if struk<>nil then
  begin
    lenTx:=StrLen(struk);
    Result:=lenTx;
    lista:=tList.Create;
    try      
      hBuf:=TworzAtomy(struk,lista);
      SendMessage(formIPSWindow,wm_User+9,9,MakeLong(formul,hBuf));
    finally
      for f:=0 to lista.count-1 do
        GlobalDeleteAtom(longint(lista.items[f]));
      lista.Free;
    end;
  end;
end;

function BylWydruk;
var
  odp: longint;
begin
  Result:=false;
  if formIPSWindow<>0 then
  begin
    odp:=SendMessage(formIPSWindow,wm_User+9,11,formul);
    Result:=odp<>0;
    if Result then
    begin
      odStr:=LoWord(odp);
      doStr:=HiWord(odp);
    end;
  end;
end;

function BylWydruk_C;
var
  odStr0,doStr0: Word;
begin
  odStr0:=0;
  doStr0:=0;
  if odStr<>nil then
    odStr0:=odStr^;
  if doStr<>nil then
    doStr0:=doStr^;
  Result:=BylWydruk(formul,odStr0,doStr0);
  if odStr<>nil then
    odStr^:=odStr0;
  if doStr<>nil then
    doStr^:=doStr0;
end;

function BylaZmiana;
begin
  Result:=false;
  if formIPSWindow<>0 then
    Result:=bool(LoWord(SendMessage(formIPSWindow,wm_User+9,10,formul)));
end;

procedure FreeSerwer;
begin
  if not IsWindow(formIPSWindow) then
    formIPSWindow:=FindWindow(serwerName,nil);
  if formIPSWindow<>0 then
    SendMessage(formIPSWindow,wm_User+9,4,0);
end;

procedure Koniec;far;
var
  f: integer;
begin
  listaCreateFormul.Free;
  for f:=listaFormul.count-1 downto 0 do
    DeleteFormul(longint(listaFormul.items[f]),0);
  parametry.Free;
  listaFormul.Free;
  FreeSerwer;
end;

procedure UnitInit;
begin
  if listaFormul=nil then
  begin
    AddExitProc(Koniec);
    listaFormul:=tList.Create;
    parametry:=tStringList.Create;
    parametry.sorted:=false;
    listaCreateFormul:=TListaCreateFormul.Create;
  end;
end;

initialization
  {$IFDEF DLL}
  UnitInit;
  {$ENDIF}
{$IFDEF WIN32}
finalization
  if hWOWLib<>0 then
    FreeLibrary(hWOWLib);
{$ENDIF}
end.


